<template>
  <div class="examination">
    <div class="common-head-search">
      <el-form :inline="true" @submit.native.prevent>
        <el-form-item label='修约名称'>
          <el-input v-model="search.reviseRuleName" size="small" placeholder="请输入查询内容"  @keyup.enter.native="searchData" style="width: 200px"></el-input>
        </el-form-item>
        <el-form-item>
          <el-button icon="el-icon-search" type="goon" size="mini" @click="searchData">查询</el-button>
          <el-button icon="el-icon-refresh" type="info" plain size="mini" @click="reset">重置</el-button>
        </el-form-item>
      </el-form>
    </div>
    <div class="common-title-div">
      <div class="common-title-name">
        <img style="width: 25px; height: 25px" src='../../../../assets/img/imgScreen/logo.png' />
        修约管理
      </div>
      <div>
      <el-button icon="el-icon-circle-plus-outline" type="goon" size="mini" @click="dialogTableVisible = true">新增</el-button>
      <el-button icon="el-icon-edit" type="goon" size="mini" @click="modify">修改</el-button>
      <el-button icon="el-icon-circle-close" type="danger" size="mini" @click="deleteData">停用</el-button>
      <el-button icon="el-icon-check" type="goon" size="mini" @click="recoverData">启用</el-button>
      </div>
    </div>
    <div class="common-table-div" style="margin-bottom:0;margin-top:0">
       <el-table v-loading="dataLoading" ref="dataTable" border :height="height_top" highlight-current-row @selection-change="handleSelectionChange" :data="table.list" :icore-filter-flag="icoreFilterFlag"
       :header-cell-style="tableHeaderCellStyle" :row-class-name="tableRowClassName" :summary-method="getSummaries" show-summary>
        <el-table-column type="index" label="NO" fixed="left" align="center"></el-table-column>
        <el-table-column type="selection" width="55" align="center"></el-table-column>
        <el-table-column sortable min-width="80px" :show-overflow-tooltip="true" prop="reviseRuleNo" label="规则代码" align="center"></el-table-column>
        <el-table-column sortable min-width="120px" :show-overflow-tooltip="true" prop="reviseRuleName" label="修约名称" align="center"></el-table-column>
        <el-table-column sortable min-width="100px" :show-overflow-tooltip="true" prop="reviseDesc" label="修约描述" align="center"></el-table-column>
        <el-table-column sortable min-width="80px" :show-overflow-tooltip="true" prop="reviseInterval" label="修约间距" align="center"></el-table-column>
        <el-table-column sortable min-width="80px" :show-overflow-tooltip="true" prop="reviseLeng" label="有效位数" align="center"></el-table-column>
        <el-table-column sortable min-width="120px" :show-overflow-tooltip="true" prop="reviseFormula" label="修约公式" align="right"></el-table-column>
        <el-table-column sortable min-width="120px" :show-overflow-tooltip="true" prop="callApi" label="调用API" align="center"></el-table-column>
        <el-table-column sortable min-width="80px" prop="validFlag1" :show-overflow-tooltip="true" label="数据状态" align="center"> </el-table-column>
        <el-table-column sortable min-width="80px" prop="memo" :show-overflow-tooltip="true" label="备注" align="center"> </el-table-column>
        <el-table-column sortable min-width="150px" :show-overflow-tooltip="true" prop="createTime" label="创建时间" align="center"></el-table-column>
        <el-table-column sortable min-width="80px" :show-overflow-tooltip="true" prop="createMan" label="创建人" align="center"></el-table-column>
        <el-table-column sortable min-width="150px" :show-overflow-tooltip="true" prop="updateTime" label="修改时间" align="center"></el-table-column>
        <el-table-column sortable min-width="80px" :show-overflow-tooltip="true" prop="updateMan" label="修改人" align="center"></el-table-column>
      </el-table>
    </div>
    <div class="common-foot-style">
        <el-pagination @size-change="pageSizeChange" @current-change="pageCurrentChange"
          :current-page="page.pageNum" :page-sizes="[10, 20, 50, 100, 200]" :page-size="page.pageSize" layout="total, sizes, prev, pager, next, jumper"
          :total="page.totalPage" background>
        </el-pagination>
    </div>
    <el-dialog @close="closeDialog('baseData')" :visible.sync="dialogTableVisible" >
        <div slot="title" class="titleBox">
        <i :class="tableType === 0? 'el-icon-document':'el-icon-edit-outline'" style="font-size: 20px"></i>
        <!-- <img style="width: 25px; height: 25px" src='../../../../assets/img/imgScreen/more.png' /> -->
        <span style="margin-left:10px;font-size:18px">{{tableTypeDsc}}</span>
        </div>
       <el-form ref="baseData" label-width="80px" :rules="ruleValidate" :model="baseData">
         <el-row>
          <el-col :span="12">
            <el-form-item prop="reviseRuleName" label="修约名称">
              <el-input v-model="baseData.reviseRuleName" size="small"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item prop="reviseDesc" label="修约描述">
              <el-input v-model="baseData.reviseDesc" size="small"></el-input>
            </el-form-item>
          </el-col>    
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="修约间距">
              <el-input v-model="baseData.reviseInterval" size="small"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item prop="reviseDesc" label="有效位数">
              <el-input v-model="baseData.reviseLeng" size="small"></el-input>
            </el-form-item>
          </el-col>    
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item prop="reviseFormula" label="修约公式">
              <el-input v-model="baseData.reviseFormula" size="small"></el-input>
            </el-form-item>
          </el-col>     
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item prop="callApi" label="调用API">
              <el-input v-model="baseData.callApi" size="small"></el-input>
            </el-form-item>
          </el-col>
         </el-row>
         <el-row>
          <el-col :span="24">
            <el-form-item  label="备注">
              <el-input v-model="baseData.memo" size="small"></el-input>
            </el-form-item>
          </el-col>
         </el-row>
       </el-form>
       <span slot="footer" class="dialog-footer">
        <el-button type="goon" size="mini" icon="el-icon-check" @click="tableType === 0 ? addData('baseData'):modifyData('baseData')">确定</el-button>
        <el-button size="mini" type="goon" icon="el-icon-remove-outline" @click="cancel()">取消</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import {
  getCookie
} from '@/utils/util.js';
import {
  cookieUserId,
  cookieUserName
} from '@/config/config.js';
import alertComponets from './alertComponents';
import alertComponets2 from './alertComponents2';
let userName = getCookie(cookieUserName);
let userId = getCookie(cookieUserId);
export default {
  components: {alertComponets, alertComponets2},
  data () {
    return {
      table: {
        list: []
      },
      dataLoading: false,
      icoreFilterFlag: true,
      dialogTableVisible:false,
      page: {
        pageSize: 50,
        pageNum: 1,
        totalPage: 0
      },
      tableType:0,
      tableTypeDsc: '新增修约规则',
      showFlag: false,
      showFlag2: false,
      Params: {},
      Params2: {},
      multipleSelection: [],
      search: {
        reviseRuleNo: '',
        reviseRuleName: ''
      },
      baseData:{},
      ruleValidate: {
        reviseRuleName: [{ required: true, message: '该项不能为空', trigger: 'blur' }]
      },
      height_top:0
    }
  },
  created() {
    this.height_top = window.innerHeight - 160;
  },
 mounted () {
    this.getDataList();
    this.addScreen()
  },
  methods: {
    getSummaries(param) {
      const { columns, data } = param;
      const sums = [];
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = "合计";
        }
        if (index === 1) {
          sums[index] = data.length;
        } 
      });
      return sums;
    },
    //新增
    addData (formName) {
        let _this = this;
        _this.tableData = [];
         _this.$refs[formName].validate((valid) => {
          if (valid) {
             _this.baseData.createMan = userName;
             _this.baseData.createNo = userId;
             _this.tableData.push(_this.baseData)
             _this.axios.post('pass/baseManagement/v1/limsbasereviserules/', _this.tableData, {individualType: 'json'}).then(res => {
                if (res.succeed) {
                  _this.dialogTableVisible = false;
                 this.$message.success('添加成功')
                 this.getDataList();
                } else {
                 this.$message.error(res.message)
                }
                }).catch(e => {
                 this.$message.error(e.message)
               })
        }
      })
    },
    //关闭弹窗
    closeDialog (formName){
      this.$refs[formName].resetFields();
      this.baseData = {}
      this.tableType = 0
      this.tableTypeDsc = '新增修约规则'
    },
    //取消
    cancel () {
      this.dialogTableVisible = false
      this.baseData = {
        reviseRuleName:'',
        reviseDesc:'',
        reviseFormula:'',
        callApi:''
      }
      this.tableType = 0
      this.tableTypeDsc = '新增修约规则'
    },
    //修改弹窗
    modify () {
      if (this.multipleSelection.length !== 1) {
        this.$message.warning('请勾选您要修改的一条数据！')
        return
      }
      this.tableType = 1
      this.tableTypeDsc = '修改修约规则'
      this.baseData = Object.assign({},this.multipleSelection[0])
      this.dialogTableVisible = true
    },
    //弹窗修改操作
    modifyData (formName) {
        let _this = this;
        _this.tableData = [];
        _this.$refs[formName].validate((valid) => {
        if (valid) {
        _this.baseData.updateMan = userName;
        _this.baseData.updateNo = userId;
        _this.axios.put('pass/baseManagement/v1/limsbasereviserules/', _this.baseData, {individualType: 'json'}).then(res => {
           if (res.succeed) {
            this.dialogTableVisible = false;
            this.$message.success('修改成功')
            this.getDataList();
           } else {
            this.$message.error(res.message)
           }
           }).catch(e => {
            this.$message.error(e.message)
          })
        }
        })
    },
    //启用
    recoverData () {
       let _this = this;
        if (_this.multipleSelection.length < 1) {
        this.$message.warning('请勾选您要启用的数据！')
      } else {
        _this.dialogTableVisible = false;
        for (var i = 0; i < _this.multipleSelection.length; i++) {
        _this.multipleSelection[i].updateMan = userName;
        _this.multipleSelection[i].updateNo = userId
        }
        _this.axios.post('pass/baseManagement/v1/limsbasereviserules/recover', _this.multipleSelection, {individualType: 'json'}).then(res => {
        if (res.succeed) {
         this.$message.success('启用成功');
         this.getDataList();
        } else {
         this.$message.error(res.message)
        }
        }).catch(e => {
         this.$message.error(e.message)
       })
      }
    },
    //删除
    deleteData () {
       let _this = this;
        if (_this.multipleSelection.length < 1) {
        this.$message.warning('请勾选您要停用的数据！')
      } else {
        _this.dialogTableVisible = false;
        for (var i = 0; i < _this.multipleSelection.length; i++) {
        _this.multipleSelection[i].updateMan = userName;
        _this.multipleSelection[i].updateNo = userId
        }
        _this.axios.post('pass/baseManagement/v1/limsbasereviserules/abolish', _this.multipleSelection, {individualType: 'json'}).then(res => {
        if (res.succeed) {
         this.$message.success('停用成功');
         this.getDataList();
        } else {
         this.$message.error(res.message)
        }
        }).catch(e => {
         this.$message.error(e.message)
       })
      }
    },
    searchData () {
      this.page.pageNum = 1;
      this.getDataList()
    },
    reset () {
      let _this = this;
      _this.search.reviseRuleNo = '';
      _this.search.reviseRuleName = '';
      _this.searchData();
    },
    handleSelectionChange (val) {
      this.multipleSelection = val;
    },
    pageSizeChange (size) {
      this.page.pageSize = size;
      this.getDataList();
    },
    pageCurrentChange (index) {
      this.page.pageNum = index;
      this.getDataList();
    },
    addScreen () {
      this.$nextTick(() => {
          let ss = document.createElement('div');
          ss.innerHTML = '筛选';
          ss.style = 'text-align: center;'
          this.$refs.dataTable.$el.getElementsByClassName('el-table__fixed')[0].getElementsByTagName('td')[0].appendChild(ss);
       });
    },
    getDataList () {
        this.dataLoading = true;
        let obj = {
          object:{
            reviseRuleName:this.search.reviseRuleName
          },
          pageIndex:this.page.pageNum,
          pageSize:this.page.pageSize
        }
        this.axios.post('pass/baseManagement/v1/limsbasereviserules/queryLimsBaseReviseRulePage', obj, {individualType: 'json'}).then(res => {
              this.dataLoading = false;
              this.table.list = res.data.list;
              for (let i = 0; i < this.table.list.length; i++) {
              if (this.table.list[i].validFlag === '0') {
                this.table.list[i].validFlag1 = '无效'
              } else if (this.table.list[i].validFlag === '1') {
                this.table.list[i].validFlag1 = '有效'
              }
              }
              this.page.totalPage = res.data.total;
            }).catch(e => {
              this.dataLoading = false;
            });
    },
    tableRowClassName ({row, column, rowIndex, columnIndex}) {
      if (row.validFlag !== '1') {
        return 'error-row';
      }
      return '';
    },
    tableHeaderCellStyle () {
      return 'color: rgb(255,255,255);border-bottom: 1px solid #DCDFE7;'
    }
  }
}
</script>
<style  scoped>
</style>
